/**
 *
 *
  _____                      _              _ _ _     _   _     _        __ _ _
 |  __ \                    | |            | (_) |   | | | |   (_)      / _(_) |
 | |  | | ___    _ __   ___ | |_    ___  __| |_| |_  | |_| |__  _ ___  | |_ _| | ___
 | |  | |/ _ \  | '_ \ / _ \| __|  / _ \/ _` | | __| | __| '_ \| / __| |  _| | |/ _ \
 | |__| | (_) | | | | | (_) | |_  |  __/ (_| | | |_  | |_| | | | \__ \ | | | | |  __/
 |_____/ \___/  |_| |_|\___/ \__|  \___|\__,_|_|\__|  \__|_| |_|_|___/ |_| |_|_|\___|

 * DO NOT EDIT THIS FILE!!
 *
 *  FOR CUSTOMIZE catalogoBaseService PLEASE EDIT ../catalogo.service.ts
 *
 *  -- THIS FILE WILL BE OVERWRITTEN ON THE NEXT SKAFFOLDER'S CODE GENERATION --
 *
 */
// DEPENDENCIES
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { map } from 'rxjs/operators';
import { HttpClient, HttpHeaders } from '@angular/common/http';

// CONFIG
import { environment } from '../../../environments/environment';

// MODEL
import { Catalogo } from '../../domain/gifloadmin_db/catalogo';
import { List } from 'lodash';

/**
 * THIS SERVICE MAKE HTTP REQUEST TO SERVER, FOR CUSTOMIZE IT EDIT ../Catalogo.service.ts
 */

/*
 * SCHEMA DB Catalogo
 *
    {
        activo: {
            type: 'String'
        },
        codigo: {
            type: 'String'
        },
        fotoNombre: {
            type: 'String'
        },
        grupo: {
            type: 'String'
        },
        nombre: {
            type: 'String'
        },
        orden: {
            type: 'Integer'
        },
        //RELATIONS
        //EXTERNAL RELATIONS
    }
 *
 */

@Injectable()
export class CatalogoBaseService {

  contextUrl: string = environment.endpoint + '/system/catalogo';
  constructor(
    protected http: HttpClient
  ) { }

  // CRUD METHODS

  /**
  * CatalogoService.create
  *   @description CRUD ACTION create
  *   @param Catalogo obj Object to insert
  *
  */
  create(item: Catalogo): Observable<Catalogo> {
    return this.http
      .post<Catalogo>(this.contextUrl, item)
      .pipe(map(data => data));
  }

  /**
  * CatalogoService.delete
  *   @description CRUD ACTION delete
  *   @param ObjectId id Id Catalogo
  *
  */
  remove(id: string): Observable<void> {
    return this.http
      .delete<void>(this.contextUrl + '/' + id)
      .pipe(map(data => data));
  }

  /**
  * CatalogoService.get
  *   @description CRUD ACTION get
  *   @param ObjectId id Id Catalogo
  *   @returns Catalogo
  *
  */
  get(id: string): Observable<Catalogo> {
    return this.http
      .get<Catalogo>(this.contextUrl + '/' + id)
      .pipe(map(data => data));
  }

  /**
  * CatalogoService.list
  *   @description CRUD ACTION list
  *   @returns ARRAY OF Catalogo
  *
  */
  list(): Observable<any> {
    return this.http
      .get<Catalogo[]>(this.contextUrl, { params: { 'page': 0, 'size': 500 } });
  }

  /**
   *
   * @returns Lista de Catalogo
   */
  listByGroup(): Observable<Catalogo[]> {
    return this.http
      .get<any>(this.contextUrl+'/search/byByGroup?grupo=FLOR_COLORES', { params: { 'page': 0, 'size': 500 } }).pipe(map(data => data['_embedded']['catalogoes']));;;
  }

  /**
  * CatalogoService.update
  *   @description CRUD ACTION update
  *   @param ObjectId id Id Catalogo
  *   @returns Catalogo
  *
  */
  update(item: Catalogo): Observable<Catalogo> {
    return this.http
      .put<Catalogo>(this.contextUrl + '/' + item.id, item)
      .pipe(map(data => data));
  }


  // Custom APIs

}
